Index: source/simulation2/system/ComponentManager.h
===================================================================
--- source/simulation2/system/ComponentManager.h	(Revision 14578)
+++ source/simulation2/system/ComponentManager.h	(Arbeitskopie)
@@ -96,6 +96,8 @@
 	void RegisterComponentType(InterfaceId, ComponentTypeId, AllocFunc, DeallocFunc, const char*, const std::string& schema);
 	void RegisterComponentTypeScriptWrapper(InterfaceId, ComponentTypeId, AllocFunc, DeallocFunc, const char*, const std::string& schema);
 
+
+    void Tick() { m_ScriptInterface.Tick(); };
 	/**
 	 * Subscribe the current component type to the given message type.
 	 * Each component's HandleMessage will be called on any BroadcastMessage of this message type,
Index: source/simulation2/components/CCmpAIManager.cpp
===================================================================
--- source/simulation2/components/CCmpAIManager.cpp	(Revision 14578)
+++ source/simulation2/components/CCmpAIManager.cpp	(Arbeitskopie)
@@ -152,7 +152,9 @@
 				ENSURE(m_Worker.m_HasLoadedEntityTemplates);
 				m_ScriptInterface->SetProperty(settings.get(), "templates", m_Worker.m_EntityTemplates, false);
 
-				obj = m_ScriptInterface->CallConstructor(ctor.get(), settings.get());
+				JS::AutoValueVector argv(m_ScriptInterface->GetContext());
+				argv.append(settings.get());
+				obj = m_ScriptInterface->CallConstructor(ctor.get(), argv.length(), argv.handleAt(0));
 			}
 			else
 			{
@@ -209,12 +211,7 @@
 	};
 
 	CAIWorker() :
-		// TODO: Passing a 32 MB argument to CreateRuntime() is a temporary fix
-		// to prevent frequent AI out-of-memory crashes. The argument should be
-		// removed as soon whenever the new pathfinder is committed
-		// And the AIs can stop relying on their own little hands.
-		m_ScriptRuntime(ScriptInterface::CreateRuntime(33554432)),
-		m_ScriptInterface(new ScriptInterface("Engine", "AI", m_ScriptRuntime)),
+		m_ScriptInterface(new ScriptInterface("Engine", "AI", g_ScriptRuntime)),
 		m_TurnNum(0),
 		m_CommandsComputed(true),
 		m_HasLoadedEntityTemplates(false),
@@ -305,7 +302,7 @@
 	static void ForceGC(ScriptInterface::CxPrivate* pCxPrivate)
 	{
 		PROFILE3("AI compute GC");
-		JS_GC(pCxPrivate->pScriptInterface->GetContext());
+		JS_GC(pCxPrivate->pScriptInterface->GetJSRuntime());
 	}
 	
 	/**
@@ -408,7 +405,10 @@
 			m_ScriptInterface->Eval("({})", fakeTech);
 			m_ScriptInterface->SetProperty(settings.get(), "techTemplates", fakeTech, false);
 		}
-		m_SharedAIObj = CScriptValRooted(m_ScriptInterface->GetContext(),m_ScriptInterface->CallConstructor(ctor.get(), settings.get()));
+		
+		JS::AutoValueVector argv(m_ScriptInterface->GetContext());
+		argv.append(settings.get());
+		m_SharedAIObj = CScriptValRooted(m_ScriptInterface->GetContext(),m_ScriptInterface->CallConstructor(ctor.get(), argv.length(), argv.handleAt(0)));
 	
 		
 		if (m_SharedAIObj.undefined())
@@ -754,14 +754,15 @@
 				m_Players[i]->Run(state, m_Players[i]->m_Player);
 		}
 
+/*
 		// Run GC if we are about to overflow
 		if (JS_GetGCParameter(m_ScriptInterface->GetJSRuntime(), JSGC_BYTES) > 33000000)
 		{
 			PROFILE3("AI compute GC");
 
-			JS_GC(m_ScriptInterface->GetContext());
+			JS_GC(m_ScriptInterface->GetJSRuntime());
 		}
-		
+	*/	
 		// Run the GC every so often.
 		// (This isn't particularly necessary, but it makes profiling clearer
 		// since it avoids random GC delays while running other scripts)
Index: source/simulation2/components/ICmpFootprint.cpp
===================================================================
--- source/simulation2/components/ICmpFootprint.cpp	(Revision 14578)
+++ source/simulation2/components/ICmpFootprint.cpp	(Arbeitskopie)
@@ -38,23 +38,23 @@
 
 	if (shape == CIRCLE)
 	{
-		jsval ptype = ScriptInterface::ToJSVal<std::string>(cx, "circle");
-		jsval pradius = ScriptInterface::ToJSVal(cx, size0);
-		jsval pheight = ScriptInterface::ToJSVal(cx, height);
-		JS_SetProperty(cx, obj, "type", &ptype);
-		JS_SetProperty(cx, obj, "radius", &pradius);
-		JS_SetProperty(cx, obj, "height", &pheight);
+		JS::RootedValue ptype(cx, ScriptInterface::ToJSVal<std::string>(cx, "circle"));
+		JS::RootedValue pradius(cx, ScriptInterface::ToJSVal(cx, size0));
+		JS::RootedValue pheight(cx, ScriptInterface::ToJSVal(cx, height));
+		JS_SetProperty(cx, obj, "type", ptype.address());
+		JS_SetProperty(cx, obj, "radius", pradius.address());
+		JS_SetProperty(cx, obj, "height", pheight.address());
 	}
 	else
 	{
-		jsval ptype = ScriptInterface::ToJSVal<std::string>(cx, "square");
-		jsval pwidth = ScriptInterface::ToJSVal(cx, size0);
-		jsval pdepth = ScriptInterface::ToJSVal(cx, size1);
-		jsval pheight = ScriptInterface::ToJSVal(cx, height);
-		JS_SetProperty(cx, obj, "type", &ptype);
-		JS_SetProperty(cx, obj, "width", &pwidth);
-		JS_SetProperty(cx, obj, "depth", &pdepth);
-		JS_SetProperty(cx, obj, "height", &pheight);
+		JS::RootedValue ptype(cx, ScriptInterface::ToJSVal<std::string>(cx, "square"));
+		JS::RootedValue pwidth(cx, ScriptInterface::ToJSVal(cx, size0));
+		JS::RootedValue pdepth(cx, ScriptInterface::ToJSVal(cx, size1));
+		JS::RootedValue pheight(cx, ScriptInterface::ToJSVal(cx, height));
+		JS_SetProperty(cx, obj, "type", ptype.address());
+		JS_SetProperty(cx, obj, "width", pwidth.address());
+		JS_SetProperty(cx, obj, "depth", pdepth.address());
+		JS_SetProperty(cx, obj, "height", pheight.address());
 	}
 
 	return OBJECT_TO_JSVAL(obj);
Index: source/simulation2/Simulation2.cpp
===================================================================
--- source/simulation2/Simulation2.cpp	(Revision 14578)
+++ source/simulation2/Simulation2.cpp	(Arbeitskopie)
@@ -155,6 +155,8 @@
 	}
 
 	int ProgressiveLoad();
+
+	void Tick();
 	void Update(int turnLength, const std::vector<SimulationCommand>& commands);
 	static void UpdateComponents(CSimContext& simContext, fixed turnLengthFixed, const std::vector<SimulationCommand>& commands);
 	void Interpolate(float simFrameLength, float frameOffset, float realFrameLength);
@@ -336,6 +338,11 @@
 	debug_warn(L"Serialization test failure");
 }
 
+void CSimulation2Impl::Tick()
+{
+    m_ComponentManager.Tick();
+}
+
 void CSimulation2Impl::Update(int turnLength, const std::vector<SimulationCommand>& commands)
 {
 	PROFILE3("sim update");
@@ -637,6 +644,11 @@
 	return m->m_ComponentManager.GetEntitiesWithInterfaceUnordered(iid);
 }
 
+void CSimulation2::Tick()
+{
+    m->Tick();
+}
+
 const CSimContext& CSimulation2::GetSimContext() const
 {
 	return m->m_SimContext;
Index: source/simulation2/Simulation2.h
===================================================================
--- source/simulation2/Simulation2.h	(Revision 14578)
+++ source/simulation2/Simulation2.h	(Arbeitskopie)
@@ -53,6 +53,7 @@
 	~CSimulation2();
 
 	void EnableOOSLog();
+	void Tick();
 	void EnableSerializationTest();
 
 	/**
Index: source/simulation2/scripting/MessageTypeConversions.cpp
===================================================================
--- source/simulation2/scripting/MessageTypeConversions.cpp	(Revision 14578)
+++ source/simulation2/scripting/MessageTypeConversions.cpp	(Arbeitskopie)
@@ -21,32 +21,39 @@
 #include "scriptinterface/ScriptInterface.h"
 #include "simulation2/MessageTypes.h"
 
-#include "js/jsapi.h"
-
 #define TOJSVAL_SETUP() \
-	JSObject* obj = JS_NewObject(scriptInterface.GetContext(), NULL, NULL, NULL); \
-	if (! obj) \
-		return JSVAL_VOID;
+	JSObject* obj; \
+	{\
+	JSAutoRequest rq(scriptInterface.GetContext()); \
+	obj = JS_NewObject(scriptInterface.GetContext(), NULL, NULL, NULL); \
+	if (!obj) \
+		return JSVAL_VOID; \
+	}
 
 #define SET_MSG_PROPERTY(name) \
 	do { \
-		jsval prop = ScriptInterface::ToJSVal(scriptInterface.GetContext(), this->name); \
-		if (! JS_SetProperty(scriptInterface.GetContext(), obj, #name, &prop)) \
+		JSAutoRequest rq(scriptInterface.GetContext()); \
+		JSContext* cx = scriptInterface.GetContext(); \
+		JS::RootedValue prop(cx, ScriptInterface::ToJSVal(cx, this->name)); \
+		if (! JS_SetProperty(cx, obj, #name, prop.address())) \
 			return JSVAL_VOID; \
 	} while (0);
 
 #define FROMJSVAL_SETUP() \
-	if (! JSVAL_IS_OBJECT(val)) \
+	if ( JSVAL_IS_PRIMITIVE(val)) \
 		return NULL; \
 	JSObject* obj = JSVAL_TO_OBJECT(val); \
-	jsval prop;
+	JS::RootedValue prop(scriptInterface.GetContext());
 
 #define GET_MSG_PROPERTY(type, name) \
-	if (! JS_GetProperty(scriptInterface.GetContext(), obj, #name, &prop)) \
+	type name; \
+	{ \
+	JSAutoRequest rq(scriptInterface.GetContext()); \
+	if (! JS_GetProperty(scriptInterface.GetContext(), obj, #name, prop.address())) \
 		return NULL; \
-	type name; \
-	if (! ScriptInterface::FromJSVal(scriptInterface.GetContext(), prop, name)) \
-		return NULL;
+	if (! ScriptInterface::FromJSVal(scriptInterface.GetContext(), prop.get(), name)) \
+		return NULL; \
+	}
 
 jsval CMessage::ToJSValCached(ScriptInterface& scriptInterface) const
 {
Index: source/simulation2/scripting/EngineScriptConversions.cpp
===================================================================
--- source/simulation2/scripting/EngineScriptConversions.cpp	(Revision 14578)
+++ source/simulation2/scripting/EngineScriptConversions.cpp	(Arbeitskopie)
@@ -34,6 +34,7 @@
 
 template<> jsval ScriptInterface::ToJSVal<IComponent*>(JSContext* cx, IComponent* const& val)
 {
+	JSAutoRequest rq(cx);
 	if (val == NULL)
 		return JSVAL_NULL;
 
@@ -58,18 +59,19 @@
 		LOGERROR(L"Failed to construct IComponent script object");
 		return JSVAL_VOID;
 	}
-	JS_SetPrivate(cx, obj, static_cast<void*>(val));
+	JS_SetPrivate(obj, static_cast<void*>(val));
 
 	return OBJECT_TO_JSVAL(obj);
 }
 
 template<> jsval ScriptInterface::ToJSVal<CParamNode>(JSContext* cx, CParamNode const& val)
 {
+	JSAutoRequest rq(cx);
 	jsval rval = val.ToJSVal(cx, true);
 
 	// Prevent modifications to the object, so that it's safe to share between
 	// components and to reconstruct on deserialization
-	if (JSVAL_IS_OBJECT(rval))
+	if (!JSVAL_IS_PRIMITIVE(rval))
 		JS_DeepFreezeObject(cx, JSVAL_TO_OBJECT(rval));
 
 	return rval;
@@ -85,19 +87,23 @@
 
 template<> bool ScriptInterface::FromJSVal<CColor>(JSContext* cx, jsval v, CColor& out)
 {
-	if (!JSVAL_IS_OBJECT(v))
+	if (JSVAL_IS_PRIMITIVE(v))
 		FAIL("jsval not an object");
 
+	JSAutoRequest rq(cx);
 	JSObject* obj = JSVAL_TO_OBJECT(v);
 
-	jsval r, g, b, a;
-	if (!JS_GetProperty(cx, obj, "r", &r) || !FromJSVal(cx, r, out.r))
+	JS::RootedValue r(cx);
+	JS::RootedValue g(cx);
+	JS::RootedValue b(cx);
+	JS::RootedValue a(cx);
+	if (!JS_GetProperty(cx, obj, "r", r.address()) || !FromJSVal(cx, r, out.r))
 		FAIL("Failed to get property CColor.r");
-	if (!JS_GetProperty(cx, obj, "g", &g) || !FromJSVal(cx, g, out.g))
+	if (!JS_GetProperty(cx, obj, "g", g.address()) || !FromJSVal(cx, g, out.g))
 		FAIL("Failed to get property CColor.g");
-	if (!JS_GetProperty(cx, obj, "b", &b) || !FromJSVal(cx, b, out.b))
+	if (!JS_GetProperty(cx, obj, "b", b.address()) || !FromJSVal(cx, b, out.b))
 		FAIL("Failed to get property CColor.b");
-	if (!JS_GetProperty(cx, obj, "a", &a) || !FromJSVal(cx, a, out.a))
+	if (!JS_GetProperty(cx, obj, "a", a.address()) || !FromJSVal(cx, a, out.a))
 		FAIL("Failed to get property CColor.a");
 	// TODO: this probably has GC bugs if a getter returns an unrooted value
 
@@ -106,26 +112,28 @@
 
 template<> jsval ScriptInterface::ToJSVal<CColor>(JSContext* cx, CColor const& val)
 {
+	JSAutoRequest rq(cx);
 	JSObject* obj = JS_NewObject(cx, NULL, NULL, NULL);
 	if (!obj)
 		return JSVAL_VOID;
 
-	jsval r = ToJSVal(cx, val.r);
-	jsval g = ToJSVal(cx, val.g);
-	jsval b = ToJSVal(cx, val.b);
-	jsval a = ToJSVal(cx, val.a);
+	JS::RootedValue r(cx, ToJSVal(cx, val.r));
+	JS::RootedValue g(cx, ToJSVal(cx, val.g));
+	JS::RootedValue b(cx, ToJSVal(cx, val.b));
+	JS::RootedValue a(cx, ToJSVal(cx, val.a));
 
-	JS_SetProperty(cx, obj, "r", &r);
-	JS_SetProperty(cx, obj, "g", &g);
-	JS_SetProperty(cx, obj, "b", &b);
-	JS_SetProperty(cx, obj, "a", &a);
+	JS_SetProperty(cx, obj, "r", r.address());
+	JS_SetProperty(cx, obj, "g", g.address());
+	JS_SetProperty(cx, obj, "b", b.address());
+	JS_SetProperty(cx, obj, "a", a.address());
 
 	return OBJECT_TO_JSVAL(obj);
 }
 
 template<> bool ScriptInterface::FromJSVal<fixed>(JSContext* cx, jsval v, fixed& out)
 {
-	jsdouble ret;
+	JSAutoRequest rq(cx);
+	double ret;
 	if (!JS_ValueToNumber(cx, v, &ret))
 		return false;
 	out = fixed::FromDouble(ret);
@@ -134,28 +142,29 @@
 	return true;
 }
 
-template<> jsval ScriptInterface::ToJSVal<fixed>(JSContext* cx, const fixed& val)
+template<> jsval ScriptInterface::ToJSVal<fixed>(JSContext* UNUSED(cx), const fixed& val)
 {
-	jsval rval = JSVAL_VOID;
-	JS_NewNumberValue(cx, val.ToDouble(), &rval); // ignore return value
+	jsval rval = JS_NumberValue(val.ToDouble());
 	return rval;
 }
 
 template<> bool ScriptInterface::FromJSVal<CFixedVector3D>(JSContext* cx, jsval v, CFixedVector3D& out)
 {
-	if (!JSVAL_IS_OBJECT(v))
+	if (JSVAL_IS_PRIMITIVE(v))
 		return false; // TODO: report type error
+
+	JSAutoRequest rq(cx);
 	JSObject* obj = JSVAL_TO_OBJECT(v);
 
-	jsval p;
+	JS::RootedValue p(cx);
 
-	if (!JS_GetProperty(cx, obj, "x", &p)) return false; // TODO: report type errors
+	if (!JS_GetProperty(cx, obj, "x", p.address())) return false; // TODO: report type errors
 	if (!FromJSVal(cx, p, out.X)) return false;
 
-	if (!JS_GetProperty(cx, obj, "y", &p)) return false;
+	if (!JS_GetProperty(cx, obj, "y", p.address())) return false;
 	if (!FromJSVal(cx, p, out.Y)) return false;
 
-	if (!JS_GetProperty(cx, obj, "z", &p)) return false;
+	if (!JS_GetProperty(cx, obj, "z", p.address())) return false;
 	if (!FromJSVal(cx, p, out.Z)) return false;
 
 	return true;
@@ -163,33 +172,35 @@
 
 template<> jsval ScriptInterface::ToJSVal<CFixedVector3D>(JSContext* cx, const CFixedVector3D& val)
 {
+	JSAutoRequest rq(cx);
 	JSObject* obj = JS_NewObject(cx, NULL, NULL, NULL);
 	if (!obj)
 		return JSVAL_VOID;
 
-	jsval x = ToJSVal(cx, val.X);
-	jsval y = ToJSVal(cx, val.Y);
-	jsval z = ToJSVal(cx, val.Z);
+	JS::RootedValue x(cx, ToJSVal(cx, val.X));
+	JS::RootedValue y(cx, ToJSVal(cx, val.Y));
+	JS::RootedValue z(cx, ToJSVal(cx, val.Z));
 
-	JS_SetProperty(cx, obj, "x", &x);
-	JS_SetProperty(cx, obj, "y", &y);
-	JS_SetProperty(cx, obj, "z", &z);
+	JS_SetProperty(cx, obj, "x", x.address());
+	JS_SetProperty(cx, obj, "y", y.address());
+	JS_SetProperty(cx, obj, "z", z.address());
 
 	return OBJECT_TO_JSVAL(obj);
 }
 
 template<> bool ScriptInterface::FromJSVal<CFixedVector2D>(JSContext* cx, jsval v, CFixedVector2D& out)
 {
-	if (!JSVAL_IS_OBJECT(v))
+	JSAutoRequest rq(cx);
+	if (JSVAL_IS_PRIMITIVE(v))
 		return false; // TODO: report type error
 	JSObject* obj = JSVAL_TO_OBJECT(v);
 
-	jsval p;
+	JS::RootedValue p(cx);
 
-	if (!JS_GetProperty(cx, obj, "x", &p)) return false; // TODO: report type errors
+	if (!JS_GetProperty(cx, obj, "x", p.address())) return false; // TODO: report type errors
 	if (!FromJSVal(cx, p, out.X)) return false;
 
-	if (!JS_GetProperty(cx, obj, "y", &p)) return false;
+	if (!JS_GetProperty(cx, obj, "y", p.address())) return false;
 	if (!FromJSVal(cx, p, out.Y)) return false;
 
 	return true;
@@ -197,52 +208,57 @@
 
 template<> jsval ScriptInterface::ToJSVal<CFixedVector2D>(JSContext* cx, const CFixedVector2D& val)
 {
+	JSAutoRequest rq(cx);
 	JSObject* obj = JS_NewObject(cx, NULL, NULL, NULL);
 	if (!obj)
 		return JSVAL_VOID;
 
-	jsval x = ToJSVal(cx, val.X);
-	jsval y = ToJSVal(cx, val.Y);
+	JS::RootedValue x(cx, ToJSVal(cx, val.X));
+	JS::RootedValue y(cx, ToJSVal(cx, val.Y));
 
-	JS_SetProperty(cx, obj, "x", &x);
-	JS_SetProperty(cx, obj, "y", &y);
+	JS_SetProperty(cx, obj, "x", x.address());
+	JS_SetProperty(cx, obj, "y", y.address());
 
 	return OBJECT_TO_JSVAL(obj);
 }
 
-template<jsint atype, typename T> jsval ToJSVal_Grid(JSContext* cx, const Grid<T>& val)
+template<> jsval ScriptInterface::ToJSVal<Grid<u8> >(JSContext* cx, const Grid<u8>& val)
 {
-	JSObject* obj = JS_NewObject(cx, NULL, NULL, NULL);
-	if (!obj)
-		return JSVAL_VOID;
+	JSAutoRequest rq(cx);
+	uint32_t length = (uint32_t)(val.m_W * val.m_H);
+	uint32_t nbytes = (uint32_t)(length * sizeof(uint8_t));
+	JSObject* objArr = JS_NewUint8Array(cx, length);
+	memcpy((void*)JS_GetUint8ArrayData(objArr), val.m_Data, nbytes);
 
-	jsuint len = val.m_W * val.m_H;
-	JSObject *darray = js_CreateTypedArray(cx, atype, len);
-	if (!darray)
-		return JSVAL_VOID;
+	JS::RootedValue data(cx, OBJECT_TO_JSVAL(objArr));
+	JS::RootedValue w(cx, ScriptInterface::ToJSVal(cx, val.m_W));
+	JS::RootedValue h(cx, ScriptInterface::ToJSVal(cx, val.m_H));
 
-	js::TypedArray *tdest = js::TypedArray::fromJSObject(darray);
-	ENSURE(tdest->byteLength == len*sizeof(T));
 
-	memcpy(tdest->data, val.m_Data, tdest->byteLength);
+	JSObject* obj = JS_NewObject(cx, NULL, NULL, NULL);
+	JS_SetProperty(cx, obj, "width", w.address());
+	JS_SetProperty(cx, obj, "height", h.address());
+	JS_SetProperty(cx, obj, "data", data.address());
 
-	jsval w = ScriptInterface::ToJSVal(cx, val.m_W);
-	jsval h = ScriptInterface::ToJSVal(cx, val.m_H);
-	jsval data = OBJECT_TO_JSVAL(darray);
-
-	JS_SetProperty(cx, obj, "width", &w);
-	JS_SetProperty(cx, obj, "height", &h);
-	JS_SetProperty(cx, obj, "data", &data);
-
 	return OBJECT_TO_JSVAL(obj);
 }
+ 
+template<> jsval ScriptInterface::ToJSVal<Grid<u16> >(JSContext* cx, const Grid<u16>& val)
+ {
+	JSAutoRequest rq(cx);
+	uint32_t length = (uint32_t)(val.m_W * val.m_H);
+	uint32_t nbytes = (uint32_t)(length * sizeof(uint16_t));
+	JSObject* objArr = JS_NewUint16Array(cx, length);
+	memcpy((void*)JS_GetUint16ArrayData(objArr), val.m_Data, nbytes);
+ 
+	JS::RootedValue data(cx, OBJECT_TO_JSVAL(objArr));
+	JS::RootedValue w(cx, ScriptInterface::ToJSVal(cx, val.m_W));
+	JS::RootedValue h(cx, ScriptInterface::ToJSVal(cx, val.m_H));
 
-template<> jsval ScriptInterface::ToJSVal<Grid<u8> >(JSContext* cx, const Grid<u8>& val)
-{
-	return ToJSVal_Grid<js::TypedArray::TYPE_UINT8>(cx, val);
-}
+	JSObject* obj = JS_NewObject(cx, NULL, NULL, NULL);
+	JS_SetProperty(cx, obj, "width", w.address());
+	JS_SetProperty(cx, obj, "height", h.address());
+	JS_SetProperty(cx, obj, "data", data.address());
 
-template<> jsval ScriptInterface::ToJSVal<Grid<u16> >(JSContext* cx, const Grid<u16>& val)
-{
-	return ToJSVal_Grid<js::TypedArray::TYPE_UINT16>(cx, val);
+	return OBJECT_TO_JSVAL(obj);
 }
Index: source/lobby/XmppClient.cpp
===================================================================
--- source/lobby/XmppClient.cpp	(Revision 14578)
+++ source/lobby/XmppClient.cpp	(Arbeitskopie)
@@ -284,7 +284,7 @@
 void XmppClient::SendIqGameReport(ScriptInterface& scriptInterface, CScriptVal data)
 {
 	glooxwrapper::JID xpartamuppJid(m_xpartamuppId);
-	jsval dataval = data.get();
+	JS::RootedValue dataval(scriptInterface.GetContext(), data.get());
 
 	// Setup some base stanza attributes
 	GameReport* game = new GameReport();
@@ -292,7 +292,7 @@
 
 	// Iterate through all the properties reported and add them to the stanza.
 	std::vector<std::string> properties;
-	scriptInterface.EnumeratePropertyNamesWithPrefix(dataval, "", properties);
+	scriptInterface.EnumeratePropertyNamesWithPrefix(JS::RootedObject(scriptInterface.GetContext(), JSVAL_TO_OBJECT(dataval)), "", properties);
 	for (std::vector<int>::size_type i = 0; i != properties.size(); i++)
 	{
 		std::wstring value;
@@ -318,7 +318,7 @@
 void XmppClient::SendIqRegisterGame(ScriptInterface& scriptInterface, CScriptVal data)
 {
 	glooxwrapper::JID xpartamuppJid(m_xpartamuppId);
-	jsval dataval = data.get();
+	JS::RootedValue dataval(scriptInterface.GetContext(), data.get());
 
 	// Setup some base stanza attributes
 	GameListQuery* g = new GameListQuery();
@@ -329,7 +329,8 @@
 
 	// Iterate through all the properties reported and add them to the stanza.
 	std::vector<std::string> properties;
-	scriptInterface.EnumeratePropertyNamesWithPrefix(dataval, "", properties);
+	JS::RootedObject dataobj(scriptInterface.GetContext(), JSVAL_TO_OBJECT(dataval.get()));
+	scriptInterface.EnumeratePropertyNamesWithPrefix(dataobj, "", properties);
 	for (std::vector<int>::size_type i = 0; i != properties.size(); i++)
 	{
 		std::wstring value;
Index: source/ps/scripting/JSInterface_VFS.cpp
===================================================================
--- source/ps/scripting/JSInterface_VFS.cpp	(Revision 14578)
+++ source/ps/scripting/JSInterface_VFS.cpp	(Arbeitskopie)
@@ -68,8 +68,8 @@
 {
 	BuildDirEntListState* s = (BuildDirEntListState*)cbData;
 
-	jsval val = ScriptInterface::ToJSVal(s->cx, CStrW(pathname.string()));
-	JS_SetElement(s->cx, s->filename_array, s->cur_idx++, &val);
+	JS::RootedValue val(s->cx, ScriptInterface::ToJSVal( s->cx, CStrW(pathname.string()) ));
+	JS_SetElement(s->cx, s->filename_array, s->cur_idx++, val.address());
 	return INFO::OK;
 }
 
@@ -191,8 +191,8 @@
 	while (std::getline(ss, line))
 	{
 		// Decode each line as UTF-8
-		jsval val = ScriptInterface::ToJSVal(cx, CStr(line).FromUTF8());
-		JS_SetElement(cx, line_array, cur_line++, &val);
+		JS::RootedValue val(cx, ScriptInterface::ToJSVal(cx, CStr(line).FromUTF8()));
+		JS_SetElement(cx, line_array, cur_line++, val.address());
 	}
 
 	return OBJECT_TO_JSVAL( line_array );
Index: source/ps/Profile.cpp
===================================================================
--- source/ps/Profile.cpp	(Revision 14578)
+++ source/ps/Profile.cpp	(Arbeitskopie)
@@ -29,13 +29,13 @@
 # define USE_CRT_SET_ALLOC_HOOK
 #endif
 
-#if defined(__GLIBC__) && !defined(NDEBUG)
-//# define USE_GLIBC_MALLOC_HOOK
-# define USE_GLIBC_MALLOC_OVERRIDE
-# include <dlfcn.h>
-# include <malloc.h>
-# include "lib/sysdep/cpu.h"
-#endif
+//#if defined(__GLIBC__) && !defined(NDEBUG)
+////# define USE_GLIBC_MALLOC_HOOK
+//# define USE_GLIBC_MALLOC_OVERRIDE
+//# include <dlfcn.h>
+//# include <malloc.h>
+//# include "lib/sysdep/cpu.h"
+//#endif
 
 #include <numeric>
 
Index: source/ps/GameSetup/GameSetup.cpp
===================================================================
--- source/ps/GameSetup/GameSetup.cpp	(Revision 14578)
+++ source/ps/GameSetup/GameSetup.cpp	(Arbeitskopie)
@@ -1099,7 +1099,7 @@
 		CStr seedArg = args.Get("autostart-random");
 
 		// Default seed is 0
-		uint32 seed = 0;
+		uint32_t seed = 0;
 		if (!seedArg.empty())
 		{
 			if (seedArg.compare("-1") == 0)
Index: source/ps/Errors.h
===================================================================
--- source/ps/Errors.h	(Revision 14578)
+++ source/ps/Errors.h	(Arbeitskopie)
@@ -72,7 +72,8 @@
 
 #include <exception>
 
-typedef u32 PSRETURN;
+//typedef u32 PSRETURN;
+typedef uint32_t PSRETURN;
 
 class PSERROR : public std::exception
 {
Index: source/ps/Replay.cpp
===================================================================
--- source/ps/Replay.cpp	(Revision 14578)
+++ source/ps/Replay.cpp	(Arbeitskopie)
@@ -127,7 +127,7 @@
 	new CProfileManager;
 	g_ScriptStatsTable = new CScriptStatsTable;
 	g_ProfileViewer.AddRootTable(g_ScriptStatsTable);
-	g_ScriptRuntime = ScriptInterface::CreateRuntime(128 * 1024 * 1024);
+	g_ScriptRuntime = ScriptInterface::CreateRuntime(256 * 1024 * 1024);
 
 	CGame game(true);
 	g_Game = &game;
@@ -210,6 +210,7 @@
 				g_Profiler2.IncrementFrameNumber();
 				PROFILE2_ATTR("%d", g_Profiler2.GetFrameNumber());
 
+                game.GetSimulation2()->Tick();
 				game.GetSimulation2()->Update(turnLength, commands);
 				commands.clear();
 			}
Index: source/scriptinterface/ScriptExtraHeaders.h
===================================================================
--- source/scriptinterface/ScriptExtraHeaders.h	(Revision 14578)
+++ source/scriptinterface/ScriptExtraHeaders.h	(Arbeitskopie)
@@ -31,6 +31,7 @@
 # endif
 # pragma GCC diagnostic ignored "-Wunused-parameter"
 # pragma GCC diagnostic ignored "-Wredundant-decls"
+# pragma GCC diagnostic ignored "-Wnon-virtual-dtor"
 # if GCC_VERSION >= 408
 #  pragma GCC diagnostic ignored "-Wunused-local-typedefs" // caused by js/debug.h
 # endif
@@ -46,8 +47,11 @@
 # define signbit std::signbit
 #endif
 
-#include "js/jstypedarray.h"
-#include "js/jsdbgapi.h"
+//#include "js/jstypedarray.h"
+//#include "jspubtd.h"
+//#include "jsatom.h"
+#include "jsfriendapi.h"
+#include "jsdbgapi.h"
 
 #undef signbit
 
@@ -57,6 +61,7 @@
 #if GCC_VERSION >= 402
 # pragma GCC diagnostic warning "-Wunused-parameter"
 # pragma GCC diagnostic warning "-Wredundant-decls"
+# pragma GCC diagnostic warning "-Wnon-virtual-dtor"
 # if GCC_VERSION >= 406
 #  pragma GCC diagnostic pop // restore user flags
 # endif
Index: source/scriptinterface/ScriptVal.h
===================================================================
--- source/scriptinterface/ScriptVal.h	(Revision 14578)
+++ source/scriptinterface/ScriptVal.h	(Arbeitskopie)
@@ -58,12 +58,16 @@
 	 */
 	jsval get() const;
 
+	void Wrap(JSContext* cx);
+
 	/**
 	 * Returns reference to the current value.
 	 * Fails if the value is not yet initialised.
 	 */
 	jsval& getRef() const;
 
+	void getPtr(JS::Value** val);
+
 	/**
 	 * Returns whether the value is uninitialised or is JSVAL_VOID.
 	 */
Index: source/scriptinterface/tests/test_ScriptConversions.h
===================================================================
--- source/scriptinterface/tests/test_ScriptConversions.h	(Revision 14578)
+++ source/scriptinterface/tests/test_ScriptConversions.h	(Arbeitskopie)
@@ -23,7 +23,7 @@
 #include "maths/MathUtil.h"
 #include "ps/CLogger.h"
 
-#include "js/jsapi.h"
+#include "jsapi.h"
 
 class TestScriptConversions : public CxxTest::TestSuite
 {
@@ -38,7 +38,7 @@
 		// We want to convert values to strings, but can't just call toSource() on them
 		// since they might not be objects. So just use uneval.
 		std::string source;
-		TS_ASSERT(script.CallFunction(OBJECT_TO_JSVAL(JS_GetGlobalObject(cx)), "uneval", CScriptVal(v1), source));
+		TS_ASSERT(script.CallFunction(OBJECT_TO_JSVAL(JS_GetGlobalForScopeChain(cx)), "uneval", CScriptVal(v1), source));
 
 		TS_ASSERT_STR_EQUALS(source, expected);
 	}
@@ -52,7 +52,7 @@
 		jsval v1 = ScriptInterface::ToJSVal(cx, value);
 
 		std::string source;
-		TS_ASSERT(script.CallFunction(OBJECT_TO_JSVAL(JS_GetGlobalObject(cx)), "uneval", CScriptVal(v1), source));
+		TS_ASSERT(script.CallFunction(OBJECT_TO_JSVAL(JS_GetGlobalForScopeChain(cx)), "uneval", CScriptVal(v1), source));
 
 		if (expected)
 			TS_ASSERT_STR_EQUALS(source, expected);
Index: source/scriptinterface/tests/test_ScriptVal.h
===================================================================
--- source/scriptinterface/tests/test_ScriptVal.h	(Revision 14578)
+++ source/scriptinterface/tests/test_ScriptVal.h	(Arbeitskopie)
@@ -20,7 +20,7 @@
 #include "scriptinterface/ScriptInterface.h"
 #include "scriptinterface/ScriptVal.h"
 
-#include "js/jsapi.h"
+#include "jsapi.h"
 
 class TestScriptVal : public CxxTest::TestSuite
 {
@@ -35,12 +35,12 @@
 
 		CScriptValRooted root(cx, OBJECT_TO_JSVAL(obj));
 
-		JS_GC(cx);
+		JS_GC(script.GetRuntime());
 
 		jsval val = INT_TO_JSVAL(123);
 		TS_ASSERT(JS_SetProperty(cx, obj, "test", &val));
 
-		JS_GC(cx);
+		JS_GC(script.GetRuntime());
 
 		jsval rval;
 		TS_ASSERT(JS_GetProperty(cx, obj, "test", &rval));
Index: source/scriptinterface/ScriptInterface.h
===================================================================
--- source/scriptinterface/ScriptInterface.h	(Revision 14578)
+++ source/scriptinterface/ScriptInterface.h	(Arbeitskopie)
@@ -25,8 +25,6 @@
 #include "ScriptTypes.h"
 #include "ScriptVal.h"
 
-#include "js/jsapi.h"
-
 #include "ps/Errors.h"
 ERROR_GROUP(Scripting);
 ERROR_TYPE(Scripting, SetupFailed);
@@ -52,8 +50,6 @@
 
 #include <boost/random/linear_congruential.hpp>
 
-class AutoGCRooter;
-
 // Set the maximum number of function arguments that can be handled
 // (This should be as small as possible (for compiler efficiency),
 // but as large as necessary for all wrapped functions)
@@ -114,6 +110,7 @@
 		void* pCBData; // meant to be used as the "this" object for callback functions
 	} m_CxPrivate;
 
+	void Tick();
 	void SetCallbackData(void* pCBData);
 	static CxPrivate* GetScriptInterfaceAndCBData(JSContext* cx);
 
@@ -136,7 +133,7 @@
 	 * Call a constructor function, equivalent to JS "new ctor(arg)".
 	 * @return The new object; or JSVAL_VOID on failure, and logs an error message
 	 */
-	jsval CallConstructor(jsval ctor, jsval arg);
+	jsval CallConstructor(jsval ctor, int argc, jsval argv);
 
 	/**
 	 * Create an object as with CallConstructor except don't actually execute the
@@ -251,9 +248,9 @@
 	 */
 	bool HasProperty(jsval obj, const char* name);
 
-	bool EnumeratePropertyNamesWithPrefix(jsval obj, const char* prefix, std::vector<std::string>& out);
+	bool EnumeratePropertyNamesWithPrefix(JS::HandleObject obj, const char* prefix, std::vector<std::string>& out);
 
-	bool SetPrototype(jsval obj, jsval proto);
+	bool SetPrototype(JS::HandleObject obj, JS::HandleObject proto);
 
 	bool FreezeObject(jsval obj, bool deep);
 
@@ -326,8 +323,6 @@
 	 */
 	template<typename T> static jsval ToJSVal(JSContext* cx, T const& val);
 
-	AutoGCRooter* ReplaceAutoGCRooter(AutoGCRooter* rooter);
-
 	/**
 	 * Dump some memory heap debugging information to stderr.
 	 */
@@ -338,6 +333,8 @@
 	 */
 	void MaybeGC();
 
+	bool MathRandom(double& nbr);
+
 	/**
 	 * Structured clones are a way to serialize 'simple' JS values into a buffer
 	 * that can safely be passed between contexts and runtimes and threads.
@@ -351,8 +348,7 @@
 	public:
 		StructuredClone();
 		~StructuredClone();
-		JSContext* m_Context;
-		uint64* m_Data;
+		uint64_t* m_Data;
 		size_t m_Size;
 	};
 
@@ -367,11 +363,11 @@
 	bool SetProperty_(jsval obj, const char* name, jsval value, bool readonly, bool enumerate);
 	bool SetProperty_(jsval obj, const wchar_t* name, jsval value, bool readonly, bool enumerate);
 	bool SetPropertyInt_(jsval obj, int name, jsval value, bool readonly, bool enumerate);
-	bool GetProperty_(jsval obj, const char* name, jsval& value);
-	bool GetPropertyInt_(jsval obj, int name, jsval& value);
+	bool GetProperty_(jsval obj, const char* name, JS::MutableHandleValue out);
+	bool GetPropertyInt_(jsval obj, int name, JS::MutableHandleValue value);
 	static bool IsExceptionPending(JSContext* cx);
-	static JSClass* GetClass(JSContext* cx, JSObject* obj);
-	static void* GetPrivate(JSContext* cx, JSObject* obj);
+	static JSClass* GetClass(JSObject* obj);
+	static void* GetPrivate(JSObject* obj);
 
 	class CustomType
 	{
@@ -383,6 +379,7 @@
 	void Register(const char* name, JSNative fptr, size_t nargs);
 	std::auto_ptr<ScriptInterface_impl> m;
 	
+	boost::rand48* m_rng;
 	std::map<std::string, CustomType> m_CustomObjectTypes;
 
 // The nasty macro/template bits are split into a separate file so you don't have to look at them
@@ -527,17 +524,19 @@
 template<typename T>
 bool ScriptInterface::GetProperty(jsval obj, const char* name, T& out)
 {
-	jsval val;
-	if (! GetProperty_(obj, name, val))
+	JSContext* cx = GetContext();
+	JSAutoRequest rq(cx);
+	JS::RootedValue val(cx);
+	if (! GetProperty_(obj, name, &val))
 		return false;
-	return FromJSVal(GetContext(), val, out);
+	return FromJSVal(cx, val, out);
 }
 
 template<typename T>
 bool ScriptInterface::GetPropertyInt(jsval obj, int name, T& out)
 {
-	jsval val;
-	if (! GetPropertyInt_(obj, name, val))
+	JS::RootedValue val(GetContext());
+	if (! GetPropertyInt_(obj, name, &val))
 		return false;
 	return FromJSVal(GetContext(), val, out);
 }
